//*******************************************************
//
//	Name: CRE_Rsler_electronic_Reverse.v2.twn.c
//	Date: 13/01/2015
//	Version: 2.00
//	Mod: AM
//
//*******************************************************
#include <sys.twn.h>

const byte MAXIDBYTES = 8;
const byte MAXIDBITS = MAXIDBYTES*8;

byte ID[MAXIDBYTES];
byte IDBitCnt;
byte TagType;

byte LastID[MAXIDBYTES];
byte LastIDBitCnt;
byte LastTagType;

void main()
{
    // Make some noise at startup at minimum volume
    Beep(BEEPSUCCESS);
    // Set maximum volume
    SetVolume(4);
    // A V24 device is sending the version at startup
    if (GetConnection() == V24)
    {
        HostSendVersion();
        HostSendChar('\r');
    }
    // Turn on green LED
    LEDSet(GREEN,ON);
    // Turn off red LED
    LEDSet(RED,OFF);
    // No transponder found up to now
    LastTagType = TAGTYPE_NONE;
    while (TRUE)
    {
        // Search a transponder
        if (TagSearch(ID,IDBitCnt,TagType))
        {
 
                // Sound a beep
                Beep(BEEPHIGH);
                // Reverse byte order
                SwapBytes(ID,(IDBitCnt+7)/8);
                // Send Prefix "h"
                HostSendChar('h');
                // Send ID with appropriate number of digits
                HostSendHex(ID,IDBitCnt,(IDBitCnt+7)/8*2);
                // Send CR \r 
                HostSendChar('\r');
                // Send LF= \n 
                 HostSendChar('\n');
                // Turn off the green LED
                LEDSet(GREEN,OFF);
                // Let the red one blink
                LEDSet(RED,BLINK);
            
            // Start a timeout of a half second
            StartTimer(0,05);
        }
        if (TestTimer(0))
        {
            LEDSet(GREEN,ON);
            LEDSet(RED,OFF);
        }
    }
}
